diff --git a/corefreqd.c b/corefreqd.c
index da29014..fb30435 100644
--- a/corefreqd.c
+++ b/corefreqd.c
@@ -488,8 +488,6 @@ void PowerInterface(SHM_STRUCT *Shm, PROC *Proc)
     }
 	Shm->Proc.Power.Unit.Times = Proc->PowerThermal.Unit.TU > 0 ?
 			1.0 / (double) (1 << Proc->PowerThermal.Unit.TU) : 0;
-	/* Scale window unit time to the driver monitoring interval.	*/
-	Shm->Proc.Power.Unit.Times *= 1000.0 / (double) Shm->Sleep.Interval;
 }
 
 void Technology_Update(SHM_STRUCT *Shm, PROC *Proc)
@@ -3796,9 +3794,8 @@ REASON_CODE Core_Manager(REF *Ref)
 		Shm->Proc.State.Energy[pw] = (double) PFlip->Delta.ACCU[pw]
 					   * Shm->Proc.Power.Unit.Joules;
 
-		Shm->Proc.State.Power[pw] =(double) PFlip->Delta.ACCU[pw]
-					  * Shm->Proc.Power.Unit.Watts
-					  * Shm->Proc.Power.Unit.Times;
+		Shm->Proc.State.Power[pw] = (1000.0*Shm->Proc.State.Energy[pw])
+					  / (double) Shm->Sleep.Interval;
 	    }
 		/* Package thermal formulas				*/
 	    if (Shm->Proc.Features.Power.EAX.PTM) {
diff --git a/corefreqk.c b/corefreqk.c
index a69d326..f851f21 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -4404,10 +4404,10 @@ void PowerThermal(CORE *Core)
 	{_Westmere_EX,		1, 1, 0},	/* 06_2F */
 
 	{_SandyBridge,		1, 1, 0},	/* 06_2A */
-	{_SandyBridge_EP,	1, 1, 1},	/* 06_2D */
+	{_SandyBridge_EP,	1, 1, 0},	/* 06_2D */
 
 	{_IvyBridge,		1, 0, 1},	/* 06_3A */
-	{_IvyBridge_EP ,	1, 1, 1},	/* 06_3E */
+	{_IvyBridge_EP ,	1, 1, 0},	/* 06_3E */
 
 	{_Haswell_DT,		1, 1, 1},	/* 06_3C */
 	{_Haswell_EP,		1, 1, 1},	/* 06_3F */
diff --git a/coretypes.h b/coretypes.h
index d0b3e69..63c4059 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.59.0"
+#define COREFREQ_VERSION	"1.59.1"
 
 enum {	GenuineIntel,
 	Core_Yonah,
